C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c sr bem01
c Simuliert Durchflusszelle 
c
c Argumente:
c
c  iread (Integer) = 5 : Optionen (1 record) von Unit 5
c                  = 0 : keine Optionen
c  iwrite   "      = 6 : Programm meldet sich auf Unit 6
c                  = 0 : programm meldet sich nicht
c  iout     "      > 0 : Ergebnisse auf File iout
c                  = 0 : Ergebnisse nicht auf File
c  kxx0     "      > 0 : Startwerte werden in array xx0 uebergeben
c                  = 0 : Startwerte sollen vom Modellfile gelesen werden
c  xx0 (d.p.(mx))      : Startwerte, Input und Output
c  res (d.p.(mx)       : Ergebnisse als pH,ctl (mikromol/l)
c -----------------------------------------------------------------------
      subroutine bem01(iread,iwrite,iout,kxx0,xx0,ires,res,ierbem,lvar)
      include 'inc001'
      include 'inc002'
      include 'inc003'
      include 'inc004'
      include 'inc005'
      character rec*80,zeit*24,upperc*80,stamp*13,model*16
     &,bemvrs*4,post*8,inp*80,nam*24
      integer trmlen
      dimension ctl(mx),dct(mx),ires(*),res(*),xx0(*)
      nflow=0
      mrep=-1
      nrep=0
      exch=0.d0
      volinp=0.d0
c
      ioptun=5
      if (lvar.le.1) then
         if(iread.eq.5) then
            read(ioptun,100) stamp
            read(ioptun,100) model
            read(ioptun,100) rec
         else
            model='NONAME'
            stamp="000000.000000"
            rec=' '
         endif
      endif
      call namext(model,nam,'v',lvar,' ')
      write(vers,107) bemvrs(),stamp,nam
107   format('BEM(',a4,'): ',a13,1x,a)
      if(iwrite.gt.0) write(iwrite,'(a)') vers(1:trmlen(vers))
      call optset(rec,ierbem)
      if(ierbem.ne.0) return
      mrep=iopt(2)
      if (iout.gt.0) then
         call namext(' ',post,'v',lvar,'r')
         call uopen(iout,'res',post)
         write(iout,100) vers
      endif
      imod=55
      call uopen(imod,'mod','.m')
100   format(a)
      rec='RUN TRACE:1 MAXIT1:20 MAXIT2:50000 relerr:1.d-6'
      call runset(rec,ierbem)
      if(ierbem.ne.0) return
      if (iout.gt.0) write(iout,100) rec
      call inpar(imod,iout,6,lvar,ierbem)
      if(ierbem.ne.0) return
      call start(imod,iout,lvar,ierbem)
      if(ierbem.ne.0) return
c
c  Test -- Verzweigungen
c
      ir=int(relerr)
      if(ir.eq.-1) then
         call dftest
      endif
c
c Bestimmung des Anfangs - Gleichgewichts
c
c     --------------------------------- Startwerte 
      do l=1,mx
         dct(l)=0.d0                     ! 27.12.93
         if(kxx0.gt.0) then
            x0(l)=xx0(l)
         else
            x0(l)=x0int(l)
         endif
      enddo
      nx=ncat+nani+nake+nslt
      vol=1.d0
      call nxtpnt(dct,nflow,ierbem)
      if(ierbem.ne.0) return
      if(iout.gt.0) then
         write(iout,105) 0
         call eqlfil(iout)
      else
         call resput(nflow,ires,res)
      endif
105   format('RES',i8)
c
c Durchf:uhrung des Versuchsablaufs
c
      if (mrep.eq.0) goto 400
      nct=ncat+nani-2
      ngroup=0
c
c Interpretation von Steuer-Zeilen
         if(iopt(1).gt.0) then
            close (unit=imod)
            imod=57
            call uopen(imod,'lnk',' ')
         endif
c
      ier=0
300   read(imod,100,end=400) inp
      call brcint(inp,rec,lvar,n)
      if (upperc(rec(1:3)).eq.'GET') then
         goto 300
      endif
      if(upperc(rec(1:3)).eq.'EXP'.or.upperc(rec(1:3)).eq.'END') then
         ngroup=ngroup+1
         if (ngroup.gt.1) go to 350
      endif
310   continue
      if (iout.gt.0) write(iout,100) rec
      if (rec(1:1).eq.'*') then
         goto 300
      else if (upperc(rec(1:3)).eq.'END') then
         go to 400
      else
         call expset(rec,irpt,exch,volinp,ierexp)
      endif
      go to 300
c
c Berechnung
c
350   continue
      if(ierexp.ne.0) then
         ierbem=200
         return
      endif
      nflow=nflow+1
      if(exch.gt.0.d0.and.volinp.gt.0.d0) then
ccc         goto 901
         call mess(201,c,r,i)
         ierbem=201
         return
      else if(exch.gt.0.d0.and.volinp.eq.0.d0) then
         fak=exch
      else if (volinp.gt.0.d0) then
         fak=volinp*1.d-3
      else
         fak=1.d0
      endif
      do 303 l=1,mx
 303     dct(l)=fak*ctin(l,1)*1.d-6
      if(ico2.ne.0) then
           k=ncat-2+ico2
           dct(k)=ctin(k,1)*1.d-3
      endif
      if(exch.gt.0.d0) then
           call ctlout(ctl)
           do 304 l=1,nct
304        if(l.ne.k) dct(l)=dct(l)-exch*ctl(l)
      endif
      call volchg(dct,vol,volinp)  
      call nxtpnt(dct,nflow,ierbem)
      if(ierbem.ne.0) return
      if(iout.gt.0) then
         write(iout,105) nflow
         call eqlfil(iout)
      else
         call resput(nflow,ires,res)
      endif 


      nrep=nrep+1
      if (mrep.gt.-1.and.nrep.ge.mrep) goto 400
      irpt=irpt-1
      if(irpt.le.0) go to 310
      call dctin
      go to 350
c
400   continue
      do l=1,mx
         xx0(l)=x0(l)
      end do
      if (iout.gt.0) then
         write(iout,100) 'end'
         close(unit=iout)
      endif
      close(unit=imod)
      ires(ires(1)+2)=nflow
      return
c
      end
