C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c BEMYIN
c BEM - batch experiment - input in tabular form
c                          as function of time (years/months)
c preprocessor which makes EXP / CTIN - records
c -------------------------------------------------------
      subroutine bemyin(ierbem)
      parameter (msfn=10,mtim=250,melm=20,mtl=22)
      implicit double precision (a-h,o-z)
      character rec*80,elm*24,tl*24,upperc*80,var*16
      integer trmlen
      dimension sfn(mtim,melm,msfn) ! single function of time
      dimension tim(mtim,msfn)      ! time in years after 1. 1. 1900
      dimension ctin(melm,2),npts(msfn),dy(melm),ipt(msfn),ctim(mtim)
     &,elm(melm),tl(mtl)
c
c read BEM - model till second "END"
c

      iend=0
 200  read(5,100) rec
      write(6,100) rec(1:trmlen(rec))
 100  format(a)
      if(upperc(rec(1:3)).eq.'END') iend=iend+1
      if(iend.lt.2) goto 200
      write(6,100) '* The following lines have been  prepared by BEMYIN'
c
c read definition data
c
      call rdrec(rec,*904)
      call wktlst(rec,tl,k)

      if(upperc(tl(1)).ne.'YIN') go to 904
      syr=1948.
      smon=0.
      dyr=1.
      dmon=0.
      flow=1.
      do l=2,k
         call varval(tl(l),var,val,0,ierbem)
         if(ierbem.ne.0) return
         if (upperc(var).eq.'FLOW') then
            flow=val
         else if (upperc(var).eq.'YR0') then
            syr=val
         else if (upperc(var).eq.'MON0') then
            smon=val
         else if (upperc(var).eq.'DYR') then
            dyr=val
         else if (upperc(var).eq.'DMON') then
            dmon=val
         else
            call mess(212,rec,r,i)
            ierbem=212
            return
         endif
      end do
      tim0=syr+smon/12.
      dtim=dyr+dmon/12.
      
      call rdrec(rec,*901)
      call wktlst(rec,elm,nelm)
c
c read component functions sfn --------------------------------
      nfdat=0
 210  call rdrec(rec,*300)
      call wktlst(rec,tl,k)
      if(k.lt.nelm+2) then
         call mess(243,rec,r,nelm+2)
         ierbem=243
         return
      endif
      read(rec,*,err=902) year,xmon,(dy(ll),ll=1,nelm)
      nfdat=nfdat+1
      xtim=year+xmon/12.
      if(nfdat.eq.1) then
         xtold=xtim
         nsf=1
      else
         if (xtim.lt.xtold) then
            nsf=nsf+1
            if(nsf.gt.msfn) then
               call mess(241,c,r,msfn)
               ierbem=241
               return
            endif
         endif
      endif
      xtold=xtim
      npts(nsf)=npts(nsf)+1
      do l=1,nelm
         sfn(npts(nsf),l,nsf)=dy(l)
         tim(npts(nsf),nsf)=xtim
      end do
      go to 210
c
c find common time division ---------------------------------------
c
 300  continue
ccc      print *,'nsf = ',nsf
c
      nctim=npts(1)

ccc      write(0,*) 'nctim=',nctim
      if (nctim.gt.mtim) then
         call mess(244,c,r,mtim)
         ierbem=244
         return
      endif

      do l1=1,npts(1)
         ctim(l1)=tim(l1,1)
      end do
      do l1=2,nsf
         call xmerge(ctim,nctim,tim(1,l1),npts(l1))
      end do
c
ccc      write(0,*) nctim , 'Zeiten' !!! test
ccc      write(0,*) (ctim(ll),ll=1,nctim) !!! test
c
c interpolate and add component functions -----------------------------
c
      do l=1,nelm
         ctin(l,1)=0.
         ctin(l,2)=0.
      end do
      do l1=1,nctim
         t=ctim(l1)
         do l=1,nelm
            ctin(l,2)=0.
         end do
         do l2=1,nsf
            do l3=1,nelm
               if(t.le.tim(1,l2)) then
                  f=sfn(1,l3,l2)
               else if (t.ge.tim(npts(l2),l2)) then
                  f=sfn(npts(l2),l3,l2)
               else
                  do l4=2,npts(l2)
                     if(tim(l4,l2).gt.t) then
                        f0=sfn(l4-1,l3,l2)
                        df=sfn(l4,l3,l2)-f0
                        t0=tim(l4-1,l2)
                        dt=tim(l4,l2)-t0
                        f=f0+(t-t0)*df/dt
                        goto 401
                     endif
                  enddo
 401              continue
               endif
ccc                  write(0,*) t,elm(l3)(1:4),l2,f !!! test
                  ctin(l3,2)=ctin(l3,2)+f
                  if(l1.eq.1) ctin(l3,1)=ctin(l3,2)
               end do
         enddo
ccc         write(0,*) t,(ctin(ll,2),ll=1,nelm) !!! test 
         if (l1.eq.1) then
            dt=ctim(1)-tim0
            write(6,104) tim0
 104        format('* year = ',f8.3)
         else
            dt=ctim(l1)-ctim(l1-1)
            write(6,104) ctim(l1-1)
         endif
         nrep=int(dt/dtim +0.5)
ccc         write(0,*) 'dt=',dt,', nrep=',nrep !!! test
         if (nrep.gt.0) then
            write(rec,101) flow,nrep
 101        format('exp_flow:',f8.3,'_nrep:',i4)
            call pack(rec,k)
            write(6,105) rec(1:k)
 105        format(a)
            do l=1,nelm
               d=(ctin(l,2)-ctin(l,1))/float(nrep)
               c=ctin(l,1)+d
ccc               write(0,*) l,c,d !!! test
               write(rec,102)c,d
               call pack(rec,k)
               write(6,103) elm(l)(1:trmlen(elm(l))),rec(1:k)
               ctin(l,1)=ctin(l,2)
               
 102           format('(',g12.4,',',g12.4,')')
 103           format('ctin ',a,':',a)
            enddo
         endif
      end do
         
c     
 700  write(6,100) 'end'
      return
c
 901  call mess(241,c,r,i)
      ierbem=241
      return

 902  call mess(202,rec,r,i)
      ierbem=202
      return

 904  call mess(240,c,r,i)
      ierbem=240
      return

      end
c
c
c
      subroutine rdrec(rec,*)
      implicit double precision (a-h,o-z)
      character rec*(*)
 200  read(5,100,end=300) rec
 100  format(a)
      if(rec(1:1).eq.'*') goto 200
      return
 300  continue
      return 1
      end
c
c
c
      subroutine pack(rec,k)
      implicit double precision (a-h,o-z)
      character rec*(*),buf*80
      k=0
      do l=1,len(rec)
         if(rec(l:l).ne.' ') then
            k=k+1
            if(rec(l:l).eq.'_') then
               buf(k:k)=' '
            else
               buf(k:k)=rec(l:l)
            endif
         endif
      enddo
      rec=buf
      return
      end
