C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c CEXINT (BEM)
c interpretiert CEX-Werte und berechnet daraus xs0, cec und pKex
c
c Dimension der CEX-Werte ist "mmol (eq) / kg"
c
      subroutine cexint(estph,eststr,estcon,ierbem)
      include 'inc001'
      include 'inc002'
      include 'inc003'
      include 'inc004'
      dimension estcon(mx),pex(mcat),pac(mcat)
c -------------------------------------------------------------
      ak=0.d0
      do 201 l=1,ncat
      if(cex(l).le.0.d0) goto 901
      ak=ak+cex(l)
201   continue
      do 202 l=1,ncat
      xs0(l)=cex(l)/ak
      pex(l)=-dlog10(xs0(l))
202   continue
c Aktivitaeten in Loesung nach der Davies - Gleichung
      str=eststr*1.d-6
      r=dsqrt(str)
      rr=r/(1.d0+r)-0.3d0*str
      do 203 l=2,ncat
         if(estcon(l-1).le.0.d0) goto 902
      pac(l)=-(dlog10(estcon(l-1))-6 - 0.5*izcat(l)*izcat(l)*rr)
203   continue
      pac(1)=estph
c Austauschkoeffizienten
      do 204 l=2,ncat
      if(exform.eq.'SEL') then
         pkgap(l)=pac(l)/izcat(l)-pac(1)+pex(1)-pex(l)/izcat(l)
      else if(exform.eq.'GAP') then
         pkgap(l)=pac(l)/izcat(l)-pac(1)+pex(1)-pex(l)
      endif
      eqex(l)=-pkgap(l)*dlog(10.d0)
204   continue
c ------------------------------------------------------------
      return
c ------------------------------------------------------------
901   call mess(218,'CEX-value',r,i)
      ierbem=218
      return
 902  call mess(218,'ESTCON('//lblcat(l)//')',r,i)
      ierbem=218
      return
      end



