C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c sr mess
c handling of messages, errors, and warnings
c
      subroutine mess(kms,cms,rms,ims)
      implicit double precision(a-h,o-z)
      character cms*(*)
      integer trmlen
      common /retcom/ ircode
      data ie/0/, im/6/
c

      ircode=8

      if(kms.eq.0) then
         return
      else if(kms.eq.100) then 
         write(ie,1000) cms(1:trmlen(cms))
 1000    format('BEM error: subcommand ',a,' not defined.')
         return
      else if(kms.eq.200) then 
         write(ie,2000) cms(1:trmlen(cms))
 2000    format('BEM error in  model, line:'/a/)
         return
      else if(kms.eq.201) then 
         write(ie,2010)
 2010    format('BEM error: Both, FLOW  and VOLINP specified.')
         return
      else if(kms.eq.202) then 
         write(ie,2020) cms(1:trmlen(cms))
 2020    format('BEM error: invalid number in line:'/a)
         return
      else if(kms.eq.203) then 
         write(ie,2030) cms(1:trmlen(cms))
 2030    format('BEM error: invalid  assignment:'/a)
         return
      else if(kms.eq.204) then 
         write(ie,2040) cms(1:trmlen(cms))
 2040    format('BEM warning. Variable ',a,' not used anymore')
         ircode=4
         return
      else if(kms.eq.205) then 
         write(ie,2050) ims,cms(1:trmlen(cms))
 2050    format('BEM error. Table overflow because > ',i3,1x,a)
         return
      else if(kms.eq.206) then 
         write(ie,2060) cms(1:trmlen(cms))
 2060    format('BEM error. Charges not balanced in salt ',a)
         return
      else if(kms.eq.207) then 
         write(ie,2070) cms(1:trmlen(cms))
 2070    format('BEM error. Wrong chemical formula: ',a)
         return
      else if(kms.eq.208) then 
         write(ie,2080) cms(1:trmlen(cms))
 2080    format('BEM error. Element not defined: "',a,'"')
         return
      else if(kms.eq.209) then 
         write(ie,2090) cms(1:trmlen(cms))
 2090    format('BEM error. Superflous definition:',a)
         return
      else if(kms.eq.210) then 
         write(ie,2100) cms(1:trmlen(cms))
 2100    format('BEM error. Unknown line type in model:'/,a)
         return
      else if(kms.eq.211) then 
         write(ie,2110) cms(1:trmlen(cms))
 2110    format('BEM error. Unknown exchange equation type: "',a,'"')
         return
      else if(kms.eq.212) then 
         write(ie,2120) cms(1:trmlen(cms))
 2120    format('BEM error. Unknown variable in:'/a)
         return
      else if(kms.eq.213) then 
         write(ie,2130) cms(1:trmlen(cms))
 2130    format('BEM error. Unknown element in:'/a)
         return
      else if(kms.eq.214) then 
         write(ie,2140) cms(1:trmlen(cms))
 2140    format('BEM error. Unknown salt in:'/a)
         return
      else if(kms.eq.215) then 
         write(ie,2150) 
 2150    format('BEM error. Do not specify CEX-values with XS0-values'
     &        ,' and/or  CEC-parameters')
         return
      else if(kms.eq.216) then 
         write(ie,2160) cms(1:trmlen(cms))
 2160    format('BEM error. Provide a value for ',a)
         return
      else if(kms.eq.217) then 
         write(ie,2170) cms(1:trmlen(cms))
 2170    format('BEM error. Total concentration <= 0 for ',a)
         return
      else if(kms.eq.218) then 
         write(ie,2180) cms(1:trmlen(cms))
 2180    format('BEM error. Provide a positive value for ',a)
         return
      else if(kms.eq.240) then 
         write(ie,2400)
 2400    format('BEM error. YIN-line expected')
         return
      else if(kms.eq.241) then 
         write(ie,2410)
 2410    format('BEM error. Element names expected')
         return
      else if(kms.eq.242) then 
         write(ie,2420)ims
 2420    format('BEM error. Table overflow in BEMYIN. > ',i2,
     &        ' component functions.')
         return
      else if(kms.eq.243) then 
         write(ie,2430)ims,cms(1:trmlen(cms))
 2430    format('BEM error. Less than ',i2,' words in line:'
     &/a)
         return
      else if(kms.eq.244) then 
         write(ie,2440)ims
 2440    format('BEM error. Table overflow in BEMYIN. > ',i5,
     &        ' points in time.')
         return
c
      else if(kms.eq.250) then 
         write(ie,2500) cms(1:trmlen(cms))
 2500    format('BEM error in link-file of cascade.'/
     &' FLOW expected instead of ',a)
         return
      else if(kms.eq.251) then 
         write(ie,2510) cms(1:trmlen(cms))
 2510    format('BEM error in link-file of cascade.'/
     &' Element ',a,' not found.')
         return
      else if(kms.eq.252) then 
         write(ie,2520) cms(1:trmlen(cms))
 2520    format('BEM error in link-file of cascade, line:'/a)
         return
      else if(kms.eq.253) then 
         write(ie,2530) cms(1:trmlen(cms))
 2530    format('BEM info. Input taken from ',a)
         return






c 
c Errors in optimiztion process
c
      else if(kms.eq.301) then 
         write(ie,3010)
 3010    format('BEM error. FEPs at step 0.'
     &        ,' Improve starting point (EST-values)')
         return
      else if(kms.eq.302) then 
         write(ie,3020)ims
 3020    format('BEM error. No convergence after ',i6,
     &        ' function calls')
         return
      else if(kms.eq.303) then 
         write(ie,3030)
 3030    format('BEM error. No convergence at step 0.'
     &        ,' Improve starting point (EST-values)')
         return

c
c BEM-section: Interpretation of results
c
      else if(kms.eq.401) then 
         write(ie,4010)cms(1:trmlen(cms))
 4010    format('BEM info. Reading results of:'/a)
         ircode=0
         return
      else if(kms.eq.402) then 
         write(ie,4020) ims
 4020    format('BEM error. Results corrupt: no equilibrium. IER=',i3)
         return
      else if(kms.eq.403) then 
         write(ie,4030)
 4030    format('BEM error. Read error in results file.')
         return
      else if(kms.eq.404) then 
         write(ie,4040)
 4040    format('BEM warning. Unexpected end of data in results file.')
         ircode=4
         return
      else if(kms.eq.410) then 
         write(ie,4100) cms(1:trmlen(cms))
 4100    format('BEM error in output definition, line:'/a/)
         return
      else if(kms.eq.411) then 
         write(ie,4110) ims
 4110    format('BEM error. Illegal code in PPVAR/PPVCPT: ',i3)
         return
      else if(kms.eq.412) then 
         write(ie,4120) ims
 4120    format('BEM error. Table overflow in STAB. >',i3,
     &        ' lines required')
         return


      endif
c
      end




