C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c RESPUT legt ausgewaehlte BEM-Ergebnisse in array RES ab
c
c   Argumente:
c
c   nflow (I)    : Versuchsschritt, beginnend mit Null
c   ires  (I,1)  : ires(1) : Anzahl der Ergebniswerte
c                  ires(1+k) : Index des k-ten Wertes
c                            k=1  :  pH
c                            1>k>= NCAT : analytische Konz. des k-ten
c                                  Kations
c                            NCAT<k     : analytische Konz. des m-ten
c                                  Anions, mit m=k-ncat, OH nicht gez.
c   res  (DP,1)  : Ergebnisse (zunaechst ires(1) Ergebnisse von
c                              Schritt 0, dann von Schritt 1 usw.)
c -------------------------------------------------------------------
      subroutine resput(nflow,ires,res)
      include 'inc001'
      include 'inc002'
      dimension ires(*),res(*),ctlc(mcat),ctla(mani)
c
      call ctl(ctlc,ctla)
c
      knxt=nflow*ires(1)
      do 201 l1=1,ires(1)
      knxt=knxt+1
      ix=ires(l1+1)
      if(ix.eq.1) then
         res(knxt)=-dlog10(ccat(1)*gam(1))
      else if (ix.le.ncat) then
         res(knxt)=ctlc(ix)*1.d6
      else
         res(knxt)=ctla(ix-ncat+1)*1.d6
      endif
201   continue
      return
      end
