C Part of BEM (Batch Equilibrium Model) Copyright (C) J. Prenzel 1994
C See File BEM.conditions for usage and copying conditions
C 
C
c sr RESTOR
c stellt alten Zustand aus eingelesen Gleichgewichts-Daten her
      subroutine restor
      include 'inc001'
      include 'inc002'
      dimension x(mx),f(mx)
c
      nx=ncat+nani+nake+nslt
      do 202 l1=1,nx
      f(l1)=0.d0
202   continue
c ---------------------------------- Ionenst:arke --------------
      x(ki)=dlog(str)
      rr=dsqrt(str)
      do 201 l=0,mz
      ff=-0.5d0*l**2*dlog(10.d0)
C     rgm(l)=ff*(rr/(1.d0+rr) - 0.3d0*str)  @  DAVIES - Gleichung
C     rgm(l)=ff*(rr/(1.d0+rr) - 0.3d0*str)
      rgm(l)=ff*(rr/(1.d0+rr) - 0.3d0*str)
Ccc      rgm(l)=ff*(rr/(1.d0+rr) )  @  G:UNTELBERG - Gleichung
ccc      rgm(l)=ff*(rr/(1.d0+rr) )
      gam(l)=dexp(rgm(l))
201   continue
      f(ki)= - str
c
C     do 301 l=1,ncat @ ------------------- Kationen -----------------
      do 301 l=1,ncat
      x(l)=dlog(ccat(l)*gam(izcat(l)))
C     f(1)=f(1) + izcat(l)*ccat(l)        @ ENB
      f(1)=f(1) + izcat(l)*ccat(l)
C     if(l.gt.1) then                  @ Bilanzen
      if(l.gt.1) then
           f(l)=-ctcat(l)+ccat(l)
      endif
C     fak=0.5d0*izcat(l)*izcat(l)     @ Ionenst:arke
C     fak=0.5d0*izcat(l)*izcat(l)
      fak=0.5d0*izcat(l)*izcat(l)
      f(ki)=f(ki) + fak*ccat(l)
301   continue
c
c -------------------------------------- Anionen ---------------------
      xoh=dlog(cani(1)*gam(1))
C     f(1)=f(1)-cani(1)       @ OH: ENB
      f(1)=f(1)-cani(1)
C     f(ki)=f(ki)+0.5*cani(1) @ OH: I
      f(ki)=f(ki)+0.5*cani(1)
      do 302 l=2,nani
      k=kani+l-2
      x(k)=dlog(cani(l)*gam(izani(l)))
C     f(1)=f(1) - izani(l)*cani(l)        @ ENB
      f(1)=f(1) - izani(l)*cani(l)
C      f(k)=-ctani(l)+cani(l)   @ Bilanzen
       f(k)=-ctani(l)+cani(l)
C     fak=0.5d0*izani(l)*izani(l)     @ Ionenst:arke
      fak=0.5d0*izani(l)*izani(l)
      f(ki)=f(ki) + fak*cani(l)
302   continue
c ----------------------------------------- Komplexe -----------------
      do 401 l1=1,ncpl
      xc=-eqcpl(l1)
      iz=iabs(izcpl(l1))
      do 402 l2=1,mptcpl
      k=idfcpl(l2*2-1,l1)
      ff=idfcpl(l2*2,l1)
      if(k.eq.0) then
           go to 403
      else if (k.gt.0) then
           xc=xc + ff*x(k)
      else if (k.eq.-1) then
           xc=xc+ff*xoh
      else
           k=kani-k-2
           xc=xc+ff*x(k)
      endif
402   continue
403   continue
      ccc=xc-rgm(iz)
      if (ccc.lt.-177.23) then
         ccpl(l1)=.999d-77
      else
         ccpl(l1)=dexp(ccc)
      endif
C     f(1)=f(1)+izcpl(l1)*ccpl(l1)              @ ENB
      f(1)=f(1)+izcpl(l1)*ccpl(l1)
c Schleife :uber Komplexkomponenten wg. Elementbilanzen
      do 406 l2=1,mptcpl
      k=idfcpl(l2*2-1,l1)
      ff=idfcpl(l2*2,l1)
C     if(k.eq.0) go to 407  @ keine weiteren Komponenten des Komplexes
C     if(k.eq.0) go to 407
      if(k.eq.0) go to 407
C     if(k.eq. 1) go to 406 @ Komponente = H
      if(k.eq. 1) go to 406
C     if(k.eq.-1) go to 406 @ Komponente = OH
      if(k.eq.-1) go to 406
C     if(k.lt.-1) k=kani-k-2 @ Anion - Komponente
      if(k.lt.-1) k=kani-k-2
C     f(k)=f(k) + ff*ccpl(l1) @ Elementbilanz
      f(k)=f(k) + ff*ccpl(l1)
406   continue
407   continue
      ff=0.5d0*iz**2
      f(ki)=f(ki)+ff*ccpl(l1)
401   continue
c ..................................... Kationenaustausch
      if(kex.eq.0) go to 600
      x(kex)=dlog(xs(1))
      f(kex)=-1.d0+xs(1)
      do 501 l=2,ncat
      if (exform.eq.'GAP') then
           frm=1.d0
      else if (exform.eq.'SEL') then
           frm=izcat(l)
      endif
      q=( x(l)/izcat(l) -x(1) +x(kex) -eqex(l) )*frm
      xs(l)=dexp(q)
      f(kex)=f(kex) + xs(l)
      f(  l)=f(  l) + xs(l)*ake/izcat(l)
501   continue
c
c .......................... Salze (L:oslichkeitsgleichgewichte)
600   continue
      if (nslt.eq.0) go to 700
      do 601 l1=1,nslt
      if(cslt(l1).le.0.d0) then
         iswslt(l1)=0
         go to 601
      else
         iswslt(l1)=1
      endif
      ks=kslt+l1-1
      x(ks)=dlog(cslt(l1))
      f(ks)=-eqslt(l1)
      do 602 l2=1,mptslt
      ke=idfslt(l2*2-1,l1)
      ff=idfslt(l2*2  ,l1)
      if(ke.eq.0) then
           go to 603
      else if (ke.eq.1) then
           f(ks)=f(ks) + ff*x(1)
      else if (ke.eq.-1) then
           f(ks)=f(ks) + ff*xoh
      else
           if (ke.lt.-1) ke=kani-ke-2
           f(ks)=f(ks) + ff*x(ke)
           f(ke)=f(ke) + ff*cslt(l1)
      endif
602   continue
603   continue
601   continue
c
c .......................... next feature
700   continue
c .......................... CO2 - Partialdruck angegeben
1000  continue
      if(ico2.eq.0) return
      k=kani-2+ico2
      f(k)=-ctani(ico2)*10.d0**(-pkco2(1)) +ccpl(ih2co3)
c .................................
      return
      end
