c spline
c kubischer spline fuer ein Intervall
c mit linearer Fortsetzung ausserhalb des Intervalls
c
c Parameter: x1,x2 (dbl.prec.) Intervall
c            y1,y2 (dbl.prec.) Funktionswerte in x1 und x2
c            d1,d2 (dbl.prec.) 1. Ableitungen in x1 und x2 



      subroutine setspl(x1,x2,y1,y2,d1,d2)
      implicit double precision (a-h,o-z)
      common /splcom/ xl,xr,yl,yr,dl,dr,a3,a2,a1,a0

      xl=x1
      xr=x2
      yl=y1
      yr=y2
      dl=d1
      dr=d2
      
      u1=y2 - y1 - 0.5*(d2-d1)*(x1+x2) 
     &   - (x2-x1)*(d2-x2*(d2-d1)/(x2-x1))
      u2=x2**3 - x1**3 - 1.5*(x2**2-x1**2)*(x1+x2)
     &   + (x2-x1)*(3*x1*x2)
      a3=u1/u2
      a2=0.5*(d2-d1)/(x2-x1) - 1.5*a3*(x2+x1)
      a1=d2-3*a3*x2**2-2*a2*x2
      a0=y2-a3*x2**3-a2*x2**2-a1*x2

      return
      end


      subroutine getspl(x,f,df)
      implicit double precision (a-h,o-z)
      common /splcom/ xl,xr,yl,yr,dl,dr,a3,a2,a1,a0

      if (x.lt.xl) then
         df=dl
         f=yl+(x-xl)*dl
      else if (x.gt.xr) then
         df=dr
         f=yr+(x-xr)*dr
      else
         f=a3*x**3 + a2*x**2 + a1*x + a0
         df=3*a3*x**2 + 2*a2*x + a1
      endif

      return
      end
