;;;====================================================================
;; fix-pad-string   returns string with  length l, right-padded with spaces
;; JP 22.10.92

(defun fix-pad-string (s l)
  (setq s (substring (concat s (make-string l ? )) 0 l)))

(defun get-line-string ()
      (cond
       ((eobp)
	nil)
       (t
	(beginning-of-line)
	(setq s (point))
	(end-of-line)
	(setq e (point))
	(forward-line)
	(buffer-substring s e))))


;; prepare table for BEM TAB

;; extract stamp and hdg from $text - file
;;
(setq txt (substitute-in-file-name "$text"))
(find-file txt)
(beginning-of-buffer)
(setq stamp (get-line-string))
(forward-line) ; ignore "TIM *" (2nd line)
(setq hdg "")
(while
  (setq rec (get-line-string))
  (setq rec (fix-pad-string rec 12))
  (setq hdg (concat hdg rec)))

(setq dat (substitute-in-file-name "$data"))
(get-buffer-create "BEM-TAB")
(switch-to-buffer "BEM-TAB")
(erase-buffer)
(auto-save-mode -1)
(setq truncate-lines t)
(insert "BEM TAB displaying results from:\n")
(insert stamp)
(newline)
(newline)
(insert hdg)
(newline)
(insert-file dat)
(setq buffer-read-only t)



